## postgresql-14 14.15

=== debian/changelog ===
postgresql-14 (14.15-0ubuntu0.22.04.1) jammy-security; urgency=medium

  * New upstream version (LP: #2085196).

    + This release encompasses changes from upstream's 14.14 and 14.15
      releases.  The former contains fixes for 4 CVEs (among other
      things), and the latter was hotfix for a problem caused by one of
      the CVE fixes from 14.14.

    + A dump/restore is not required for those running 14.X.

    + However, if you are upgrading from a version earlier than 14.12, see
      those release notes as well please.

    + Ensure cached plans are marked as dependent on the calling role when
      RLS applies to a non-top-level table reference (Nathan Bossart)

      If a CTE, subquery, sublink, security invoker view, or coercion
      projection in a query references a table with row-level security
      policies, we neglected to mark the resulting plan as potentially
      dependent on which role is executing it.  This could lead to later query
      executions in the same session using the wrong plan, and then returning
      or hiding rows that should have been hidden or returned instead.

      The PostgreSQL Project thanks Wolfgang Walther for reporting this
      problem.
      (CVE-2024-10976)

    + Make libpq discard error messages
      received during SSL or GSS protocol negotiation (Jacob Champion)

      An error message received before encryption negotiation is completed
      might have been injected by a man-in-the-middle, rather than being real
      server output.  Reporting it opens the door to various security hazards;
      for example, the message might spoof a query result that a careless user
      could mistake for correct output.  The best answer seems to be to
      discard such data and rely only on libpq's own report of the connection
      failure.

      The PostgreSQL Project thanks Jacob Champion for reporting this
      problem.
      (CVE-2024-10977)

    + Fix unintended interactions between SET SESSION AUTHORIZATION
      and SET ROLE (Tom Lane)

      The SQL standard mandates that SET SESSION AUTHORIZATION have a
      side-effect of doing SET ROLE NONE.  Our implementation of that was
      flawed, creating more interaction between the two settings than
      intended.  Notably, rolling back a transaction that had done SET SESSION
      AUTHORIZATION would revert ROLE to NONE even if that had not been the
      previous state, so that the effective user ID might now be different
      from what it had been before the transaction.  Transiently setting
      session_authorization in a function SET clause had a similar effect.  A
      related bug was that if a parallel worker inspected
      current_setting('role'), it saw none even when it should see something
      else.

      The PostgreSQL Project thanks Tom Lane for reporting this problem.
      (CVE-2024-10978)

    + Prevent trusted PL/Perl code from changing environment variables
      (Andrew Dunstan, Noah Misch)

      The ability to manipulate process environment variables such as PATH
      gives an attacker opportunities to execute arbitrary code.  Therefore,
      trustedPLs must not offer the ability to do that.  To fix plperl,
      replace %ENV with a tied hash that rejects any modification attempt with
      a warning.  Untrusted plperlu retains the ability to change the
      environment.

      The PostgreSQL Project thanks Coby Abrams for reporting this problem.
      (CVE-2024-10979)

    + Restore functionality of ALTER {ROLE|DATABASE} SET
      role (Tom Lane, Noah Misch)

      The fix for CVE-2024-10978 accidentally caused settings for role to
      not be applied if they come from non-interactive sources, including
      previous ALTER {ROLE|DATABASE} commands and the PGOPTIONS environment
      variable.

    + Details about these and many further changes can be found at:
      https://www.postgresql.org/docs/14/release-14-14.html and
      https://www.postgresql.org/docs/14/release-14-15.html.

  * d/postgresql-14.NEWS: Update.

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Mon, 25 Nov 2024 16:05:41 -0500

postgresql-14 (14.13-0ubuntu0.22.04.1) jammy-security; urgency=medium

  * New upstream version (LP: #2076183).

    + A dump/restore is not required for those running 14.X.

    + However, if you are upgrading from a version earlier than 14.12, see
      those release notes as well please.

    + Prevent unauthorized code execution during pg_dump (Masahiko Sawada)

      An attacker able to create and drop non-temporary objects could inject
      SQL code that would be executed by a concurrent pg_dump session with the
      privileges of the role running pg_dump (which is often a superuser).
      The attack involves replacing a sequence or similar object with a view
      or foreign table that will execute malicious code.  To prevent this,
      introduce a new server parameter restrict_nonsystem_relation_kind that
      can disable expansion of non-builtin views as well as access to foreign
      tables, and teach pg_dump to set it when available.  Note that the
      attack is prevented only if both pg_dump and the server it is dumping
      from are new enough to have this fix.

      The PostgreSQL Project thanks Noah Misch for reporting this problem.
      (CVE-2024-7348)

    + Details about these and many further changes can be found at:
      https://www.postgresql.org/docs/14/release-14-13.html.

  * d/postgresql-14.NEWS: Update.
  * d/p/focal-arm64-outline-atomics: refresh patch.

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Tue, 06 Aug 2024 15:14:44 -0300

## postgresql-14 14.17

=== contrib/postgres_fdw/Makefile ===
# contrib/postgres_fdw/Makefile

MODULE_big = postgres_fdw
OBJS = \
	$(WIN32RES) \
	connection.o \
	deparse.o \
	option.o \
	postgres_fdw.o \
	shippable.o
PGFILEDESC = "postgres_fdw - foreign data wrapper for PostgreSQL"

PG_CPPFLAGS = -I$(libpq_srcdir)
SHLIB_LINK_INTERNAL = $(libpq)

EXTENSION = postgres_fdw
DATA = postgres_fdw--1.0.sql postgres_fdw--1.0--1.1.sql

REGRESS = postgres_fdw

ifdef USE_PGXS
PG_CONFIG = pg_config
PGXS := $(shell $(PG_CONFIG) --pgxs)
include $(PGXS)
else
SHLIB_PREREQS = submake-libpq
subdir = contrib/postgres_fdw
top_builddir = ../..
include $(top_builddir)/src/Makefile.global
include $(top_srcdir)/contrib/contrib-global.mk
endif

=== debian/changelog ===
postgresql-14 (14.17-1.pgdg20.04+1) focal-pgdg; urgency=medium

  * Rebuild for focal-pgdg.
  * Changes applied by generate-pgdg-source:
    + Moving lib packages to component 14.
    + Remove tzdata-legacy from build and test dependencies.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Tue, 18 Feb 2025 11:59:37 +0100

postgresql-14 (14.17-1) unstable; urgency=medium

  * New upstream version 14.17.

    + Improve behavior of libpq's quoting functions (Andres Freund, Tom Lane)

      The changes made for CVE-2025-1094 had one serious oversight:
      PQescapeLiteral() and PQescapeIdentifier() failed to honor their string
      length parameter, instead always reading to the input string's trailing
      null.  This resulted in including unwanted text in the output, if the
      caller intended to truncate the string via the length parameter.  With
      very bad luck it could cause a crash due to reading off the end of
      memory.

      In addition, modify all these quoting functions so that when invalid
      encoding is detected, an invalid sequence is substituted for just the
      first byte of the presumed character, not all of it.  This reduces the
      risk of problems if a calling application performs additional processing
      on the quoted string.

 -- Christoph Berg <myon@debian.org>  Tue, 18 Feb 2025 11:59:37 +0100

postgresql-14 (14.16-1) unstable; urgency=medium

  * New upstream version 14.16.

    + Harden PQescapeString and allied functions against invalidly-encoded
      input strings (Andres Freund, Noah Misch)

      Data-quoting functions supplied by libpq now fully check the encoding
      validity of their input.  If invalid characters are detected, they
      report an error if possible.  For the ones that lack an error return
      convention, the output string is adjusted to ensure that the server will
      report invalid encoding and no intervening processing will be fooled by
      bytes that might happen to match single quote, backslash, etc.

      The purpose of this change is to guard against SQL-injection attacks
      that are possible if one of these functions is used to quote crafted
      input.  There is no hazard when the resulting string is sent directly to
      a PostgreSQL server (which would check its encoding anyway), but there
      is a risk when it is passed through psql or other client-side code.
      Historically such code has not carefully vetted encoding, and in many
      cases it's not clear what it should do if it did detect such a problem.

      This fix is effective only if the data-quoting function, the server, and
      any intermediate processing agree on the character encoding that's being
      used.  Applications that insert untrusted input into SQL commands should
      take special care to ensure that that's true.

      Applications and drivers that quote untrusted input without using these
      libpq functions may be at risk of similar problems.  They should first
      confirm the data is valid in the encoding expected by the server.

      The PostgreSQL Project thanks Stephen Fewer for reporting this problem.
      (CVE-2025-1094)

  * B-D on postgresql-common-dev.
  * Test-depend only our server packages, i.e. allow libpq5 to be newer.

 -- Christoph Berg <myon@debian.org>  Tue, 11 Feb 2025 11:27:41 +0100

postgresql-14 (14.15-1) unstable; urgency=medium

  * New upstream version 14.15.

    + Repair ABI break for extensions that work with struct ResultRelInfo

      Last week's minor releases unintentionally broke binary compatibility
      with timescaledb and several other extensions.  Restore the affected
      structure to its previous size, so that such extensions need not be
      rebuilt.

    + Restore functionality of ALTER {ROLE|DATABASE} SET role

      The fix for CVE-2024-10978 accidentally caused settings for role to not
      be applied if they come from non-interactive sources, including previous
      ALTER {ROLE|DATABASE} commands and the PGOPTIONS environment variable.

 -- Christoph Berg <myon@debian.org>  Tue, 19 Nov 2024 15:36:12 +0100

postgresql-14 (14.14-1) unstable; urgency=medium

  * New upstream version 14.14.

    + Ensure cached plans are marked as dependent on the calling role when RLS
      applies to a non-top-level table reference (Nathan Bossart)

      If a CTE, subquery, sublink, security invoker view, or coercion
      projection in a query references a table with row-level security
      policies, we neglected to mark the resulting plan as potentially
      dependent on which role is executing it.  This could lead to later query
      executions in the same session using the wrong plan, and then returning
      or hiding rows that should have been hidden or returned instead.

      The PostgreSQL Project thanks Wolfgang Walther for reporting this
      problem. (CVE-2024-10976)

    + Make libpq discard error messages received during SSL or GSS protocol
      negotiation (Jacob Champion)

      An error message received before encryption negotiation is completed
      might have been injected by a man-in-the-middle, rather than being real
      server output.  Reporting it opens the door to various security hazards;
      for example, the message might spoof a query result that a careless user
      could mistake for correct output.  The best answer seems to be to
      discard such data and rely only on libpq's own report of the connection
      failure.

      The PostgreSQL Project thanks Jacob Champion for reporting this problem.
      (CVE-2024-10977)

    + Fix unintended interactions between SET SESSION AUTHORIZATION and SET
      ROLE (Tom Lane)

      The SQL standard mandates that SET SESSION AUTHORIZATION have a
      side-effect of doing SET ROLE NONE.  Our implementation of that was
      flawed, creating more interaction between the two settings than


=== debian/control ===
Source: postgresql-14
Section: database
Priority: optional
Maintainer: Debian PostgreSQL Maintainers <team+postgresql@tracker.debian.org>
Uploaders:
 Martin Pitt <mpitt@debian.org>,
 Peter Eisentraut <petere@debian.org>,
 Christoph Berg <myon@debian.org>,
Standards-Version: 4.5.0
Rules-Requires-Root: no
Build-Depends:
 autoconf,
 bison,
 clang [!alpha !hppa !hurd-i386 !ia64 !kfreebsd-amd64 !kfreebsd-i386 !m68k !powerpc !riscv64 !sh4 !sparc64 !x32],
 debhelper-compat (= 13),
 dh-exec (>= 0.13~),
 docbook-xml,
 docbook-xsl (>= 1.77),
 dpkg-dev (>= 1.16.1~),
 flex,
 gdb <!nocheck>,
 gettext,
 libicu-dev,
 libio-pty-perl <!nocheck>,
 libipc-run-perl <!nocheck>,
 libkrb5-dev,
 libldap2-dev,
 liblz4-dev,
 libpam0g-dev | libpam-dev,
 libperl-dev,
 libpq-dev <pkg.postgresql.nolibpkgs>,
 libreadline-dev,
 libselinux1-dev [linux-any],
 libssl-dev,
 libsystemd-dev [linux-any],
 libxml2-dev,
 libxml2-utils,
 libxslt1-dev,
 llvm-dev [!alpha !hppa !hurd-i386 !ia64 !kfreebsd-amd64 !kfreebsd-i386 !m68k !powerpc !riscv64 !sh4 !sparc64 !x32],
 mawk,
 perl (>= 5.8),
 pkgconf,
 postgresql-common-dev,
 python3-dev,
 systemtap-sdt-dev,
 tcl-dev,
 tzdata <!nocheck>,
 uuid-dev,
 xsltproc,
 zlib1g-dev | libz-dev,
Homepage: http://www.postgresql.org/
Vcs-Browser: https://salsa.debian.org/postgresql/postgresql
Vcs-Git: https://salsa.debian.org/postgresql/postgresql.git -b 14

Package: libpq-dev
Build-Profiles: <!pkg.postgresql.nolibpkgs>
Architecture: any
Section: 14/libdevel
Depends:
 libpq5 (= ${binary:Version}),
 libssl-dev,
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 postgresql-doc-14,
Description: header files for libpq5 (PostgreSQL library)
 Header files and static library for compiling C programs to link
 with the libpq library in order to communicate with a PostgreSQL
 database backend.
 .
 PostgreSQL is an object-relational SQL database management system.

Package: libpq5
Build-Profiles: <!pkg.postgresql.nolibpkgs>
Architecture: any
Section: 14/libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Multi-Arch: same
Description: PostgreSQL C client library
 libpq is a C library that enables user programs to communicate with
 the PostgreSQL database server.  The server can be on another machine
 and accessed through TCP/IP.  This version of libpq is compatible
 with servers from PostgreSQL 8.2 or later.
 .
 This package contains the run-time library, needed by packages using
 libpq.
 .
 PostgreSQL is an object-relational SQL database management system.

Package: libecpg6
Build-Profiles: <!pkg.postgresql.nolibpkgs>
Architecture: any
Section: 14/libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Multi-Arch: same
Description: run-time library for ECPG programs
 The libecpg shared library is used by programs built with ECPG
 (Embedded PostgreSQL for C).
 .
 PostgreSQL is an object-relational SQL database management system.

Package: libecpg-dev
Build-Profiles: <!pkg.postgresql.nolibpkgs>
Architecture: any
Section: 14/libdevel
Depends:
 libecpg-compat3 (= ${binary:Version}),
 libecpg6 (= ${binary:Version}),
 libpgtypes3 (= ${binary:Version}),
 libpq-dev,
 ${misc:Depends},
 ${shlibs:Depends},
Description: development files for ECPG (Embedded PostgreSQL for C)
 This package contains the necessary files to build ECPG (Embedded
 PostgreSQL for C) programs.  It includes the development libraries
 and the preprocessor program ecpg.
 .
 PostgreSQL is an object-relational SQL database management system.
 .
 Install this package if you want to write C programs with SQL statements
 embedded in them (rather than run by an external process).

Package: libecpg-compat3
Build-Profiles: <!pkg.postgresql.nolibpkgs>
Architecture: any
Section: 14/libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Multi-Arch: same
Description: older version of run-time library for ECPG programs
 The libecpg_compat shared library is used by programs built with ecpg.
 (Embedded PostgreSQL for C).
 .
 PostgreSQL is an object-relational SQL database management system.

Package: libpgtypes3
Build-Profiles: <!pkg.postgresql.nolibpkgs>
Architecture: any
Section: 14/libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Multi-Arch: same
Description: shared library libpgtypes for PostgreSQL 14
 The libpgtypes shared library is used by programs built with ecpg.
 (Embedded PostgreSQL for C).
 .
 PostgreSQL is an object-relational SQL database management system.

Package: postgresql-14
Architecture: any
Depends:
 locales | locales-all,
 postgresql-client-14,
 postgresql-common (>= 229~),
 ssl-cert,
 tzdata,
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 postgresql-contrib-14,
 postgresql-14-jit-llvm (= ${llvm:Version}) [!alpha !hppa !hurd-i386 !ia64 !kfreebsd-amd64 !kfreebsd-i386 !m68k !powerpc !riscv64 !sh4 !sparc64 !x32],
Recommends:
 sysstat,
Description: The World's Most Advanced Open Source Relational Database
 PostgreSQL, also known as Postgres, is a free and open-source relational
 database management system (RDBMS) emphasizing extensibility and SQL
 compliance. It features transactions with Atomicity, Consistency, Isolation,
 Durability (ACID) properties, automatically updatable views, materialized
 views, triggers, foreign keys, and stored procedures. It is designed to handle
 a range of workloads, from single machines to data warehouses or Web services
 with many concurrent users.
 .
 This package provides the database server for PostgreSQL 14.${cassert}
XB-Postgresql-Catversion: ${postgresql:Catversion}

Package: postgresql-client-14
Architecture: any
Multi-Arch: foreign
Depends:
 libpq5 (>= ${source:Upstream-Version}),
 postgresql-client-common (>= 182~),
 sensible-utils,
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 postgresql-14,
 postgresql-doc-14,
Provides:
 postgresql-client,
Description: front-end programs for PostgreSQL 14
 This package contains client and administrative programs for
 PostgreSQL: these are the interactive terminal client psql and
 programs for creating and removing users and databases.
 .
 This is the client package for PostgreSQL 14. If you install
 PostgreSQL 14 on a standalone machine, you need the server package
 postgresql-14, too. On a network, you can install this package on
 many client machines, while the server package may be installed on
 only one machine.
 .
 PostgreSQL is an object-relational SQL database management system.

Package: postgresql-server-dev-14
Architecture: any
Section: libdevel
Depends:
 clang-${llvm:Version} [!alpha !hppa !hurd-i386 !ia64 !kfreebsd-amd64 !kfreebsd-i386 !m68k !powerpc !riscv64 !sh4 !sparc64 !x32],
 libpq-dev (>= 14~~),
 llvm-${llvm:Version}-dev [!alpha !hppa !hurd-i386 !ia64 !kfreebsd-amd64 !kfreebsd-i386 !m68k !powerpc !riscv64 !sh4 !sparc64 !x32],
 postgresql-client-14,
 postgresql-common (>= 142~),
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 postgresql-server-dev-all (<< 181~),
Description: development files for PostgreSQL 14 server-side programming
 Header files for compiling SSI code to link into PostgreSQL's backend; for
 example, for C functions to be called from SQL.
 .
 This package also contains the Makefiles necessary for building add-on
 modules of PostgreSQL, which would otherwise have to be built in the
 PostgreSQL source-code tree.
 .
 PostgreSQL is an object-relational SQL database management system.

Package: postgresql-doc-14
Architecture: all
Multi-Arch: foreign
Section: doc
Depends:
 ${misc:Depends},
Breaks:
 postgresql-common (<< 158~),
Description: documentation for the PostgreSQL database management system
 This package contains all README files, user manual, and examples for
 PostgreSQL 14. The manual is in HTML format.
 .
 PostgreSQL is an object-relational SQL database management system.

Package: postgresql-plperl-14
Architecture: any
Depends:
 perl,
 postgresql-14 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 postgresql-plperl,
Description: PL/Perl procedural language for PostgreSQL 14
 PL/Perl enables an SQL developer to write procedural language functions
 for PostgreSQL 14 in Perl.  You need this package if you have any
 PostgreSQL 14 functions that use the languages plperl or plperlu.
 .
 PostgreSQL is an object-relational SQL database management system.

Package: postgresql-plpython3-14
Architecture: any
Depends:
 postgresql-14 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 postgresql-plpython3,
Description: PL/Python 3 procedural language for PostgreSQL 14
 PL/Python 3 enables an SQL developer to write procedural language functions
 for PostgreSQL 14 in Python 3.  You need this package if you have any
 PostgreSQL 14 functions that use the languages plpython3 or plpython3u.
 .
 PostgreSQL is an object-relational SQL database management system.

Package: postgresql-pltcl-14
Architecture: any
Depends:
 postgresql-14 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 postgresql-pltcl,
Description: PL/Tcl procedural language for PostgreSQL 14
 PL/Tcl enables an SQL developer to write procedural language functions
 for PostgreSQL 14 in Tcl.  You need this package if you have any
 PostgreSQL 14 functions that use the languages pltcl or pltclu.
 .
 PostgreSQL is an object-relational SQL database management system.

=== debian/tests/control ===
Tests: run-testsuite
Depends:
 build-essential,
 debhelper,
 fakeroot,
 hunspell-en-us,
 iproute2,
 locales-all,
 logrotate,
 netcat-openbsd,
 perl,
 procps,
 libecpg-dev,
 postgresql-14,
 postgresql-client-14,
 postgresql-server-dev-14,
 postgresql-doc-14,
 postgresql-plperl-14,
 postgresql-plpython3-14,
 postgresql-pltcl-14,
Restrictions: needs-root

Tests: installcheck
Depends:
 build-essential,
 tzdata,
 postgresql-14,
Restrictions: allow-stderr

## postgresql-14 14.18

=== contrib/uuid-ossp/Makefile ===
# contrib/uuid-ossp/Makefile

MODULE_big = uuid-ossp
OBJS = \
	$(WIN32RES) \
	uuid-ossp.o

EXTENSION = uuid-ossp
DATA = uuid-ossp--1.1.sql uuid-ossp--1.0--1.1.sql
PGFILEDESC = "uuid-ossp - UUID generation"

REGRESS = uuid_ossp

SHLIB_LINK += $(UUID_LIBS)

# We copy some needed files verbatim from pgcrypto
pgcrypto_src = $(top_srcdir)/contrib/pgcrypto

PG_CPPFLAGS = -I$(pgcrypto_src)

ifdef USE_PGXS
PG_CONFIG = pg_config
PGXS := $(shell $(PG_CONFIG) --pgxs)
include $(PGXS)
else
subdir = contrib/uuid-ossp
top_builddir = ../..
include $(top_builddir)/src/Makefile.global
include $(top_srcdir)/contrib/contrib-global.mk
endif

=== debian/changelog ===
postgresql-14 (14.18-1.pgdg130+~20250512.0418.g4bccb09) trixie-pgdg; urgency=medium

  * Rebuild for trixie-pgdg.
  * Changes applied by generate-pgdg-source:
    + Merge Debian packaging repository (14) with upstream (REL_14_STABLE).
    + Moving lib packages to component 14.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Tue, 06 May 2025 17:55:19 +0200

postgresql-14 (14.18-1) unstable; urgency=medium

  * New upstream version 14.18.

    + Avoid one-byte buffer overread when examining invalidly-encoded strings
      that are claimed to be in GB18030 encoding (Noah Misch, Andres Freund)

      While unlikely, a SIGSEGV crash could occur if an incomplete multibyte
      character appeared at the end of memory.  This was possible both in the
      server and in libpq-using applications. (CVE-2025-4207)

  * Revert "Test-depend only our server packages".

 -- Christoph Berg <myon@debian.org>  Tue, 06 May 2025 17:55:19 +0200

=== debian/control ===
--- 
+++ 
@@ -45,6 +45,7 @@
  systemtap-sdt-dev,
  tcl-dev,
  tzdata <!nocheck>,
+ tzdata-legacy <!nocheck> | tzdata (<< 2023c-8) <!nocheck>,
  uuid-dev,
  xsltproc,
  zlib1g-dev | libz-dev,
